### MP Fénelon Sainte-Marie --- Informatique
### Informatique 9 --- Résolution approchée d'équations différentielles (2/2)
################################################################

import numpy as np
import matplotlib.pyplot as plt
plt.clf()

################################################################

def Euler(f,y0,a,b,n,s):
    h=(b-a)/n
    x = np.zeros(n+1)
    y = np.zeros(n+1)
    x[0] = a
    y[0]=y0
    for i in range(n):
        x[i+1]=x[i]+h
        y[i+1]=y[i]+h*f(x[i],y[i])
    plt.plot(x,y,s,label='Euler pour n='+str(n))
    print("Approximation Euler :",y[n],"pour n=",n)

################################################################

def RungeKutta2(f,y0,a,b,n,s):
    h=(b-a)/n
    x = np.zeros(n+1)
    y = np.zeros(n+1)
    x[0] = a
    y[0]=y0
    for i in range(n):
        x[i+1]=x[i]+h
        k1=y[i]+(h/2)*f(x[i],y[i])
        k2=f(x[i]+(h/2),k1)
        y[i+1]=y[i]+h*k2
    plt.plot(x,y,s,label='RK2 pour n='+str(n))
    print("Approximation RK2 :",y[n],"pour n=",n)

################################################################

def RungeKutta4(f,y0,a,b,n,s):
    h=(b-a)/n
    x = np.zeros(n+1)
    y = np.zeros(n+1)
    x[0] = a
    y[0]=y0
    for i in range(n):
        x[i+1]=x[i]+h
        k1=f(x[i],y[i])
        k2=f(x[i]+(h/2),y[i]+h*k1/2)
        k3=f(x[i]+(h/2),y[i]+h*k2/2)
        k4=f(x[i]+h,y[i]+h*k3)
        y[i+1]=y[i]+h*(k1+2*k2+2*k3+k4)/6
    plt.plot(x,y,s,label='RK4 pour n='+str(n))
    print("Approximation RK4 :",y[n],"pour n=",n)

################################################################
################################################################


print("Résolution de y'(t)=t+y(t) et y(0)=1")

def f1(t,y):
    return t+y

plt.clf()

CondInit1=1
CondInit=1
a1=0
b1=4
b = 4
n=10
print("Vraie valeur y(b)=",-1-b+2*np.exp(b))
Euler(f1,CondInit1,a1,b1,10,'k+')
Euler(f1,CondInit1,a1,b1,100,'g+')
RungeKutta2(f1,CondInit,a1,b1,10,'ro')
RungeKutta4(f1,CondInit,a1,b1,10,'bo')
x=np.linspace(a1,b1,100)
plt.plot(x,-1-x+2*np.exp(x),label='$x\mapsto-1-x+2e^x$')
plt.legend(loc='upper left')

"""
print("Résolution de y'(t)=cos(t)-sin(t)+y(t) et y(0)=0, de solution y = sin")

def f2(t,y):
    return np.cos(t) - np.sin(t) + y

CondInit2=0
a2 = 0
b2 = 2 * np.pi
n=10
print("Vraie valeur y(b)=",np.sin(b2))
#Euler(f2,CondInit2,a2,b2,10,'k+')
Euler(f2,CondInit2,a2,b2,10*n,'g+')
RungeKutta2(f2,CondInit2,a2,b2,n,'ro')
RungeKutta4(f2,CondInit2,a2,b2,n,'bo')
x=np.linspace(a2,b2,100)
plt.plot(x,np.sin(x),label='$x\mapsto \sin x$')
plt.legend(loc='upper right')
"""
plt.show()